(*
Copyright 2009 Christian Sternagel, René Thiemann, Sarah Winkler, Harald Zankl

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
header {* Datatype either *}
theory Either imports Main begin

datatype ('a,'b)either = Left 'a | Right 'b

primrec left where "left(Left l) = l"

primrec right where "right(Right r) = r"

text {* On a list of @{text either}s, apply @{text f} to every @{const Left}
element and @{text g} to every @{const Right} element. *}
abbreviation map :: "('a \<Rightarrow> 'c) \<Rightarrow> ('b \<Rightarrow> 'c) \<Rightarrow> ('a,'b)either list \<Rightarrow> 'c list"
  where "map f g \<equiv> List.map (\<lambda>e. case e of Left l \<Rightarrow> f l | Right r \<Rightarrow> g r)"

text {* We do not want to override @{const "List.map"} and hence have
to hide the (unqualified) name of @{const "Either.map"}. *}
hide (open) const map

end
